#*=============================================================================
#* FileName: SaveIETabs.ps1
#*=============================================================================
#* Script Name: [Save IE Tabs]
#* Version: 1.1
#* Created: [12/20/2011]
#* Author: Bharat Suneja*
#* Email:  bsuneja@live.com
#* Web: http://www.exchangepedia.com
#* Reqrmnts: Tested with PSv2
#*=============================================================================
#* Purpose: Save all open Internet Explorer tabs as IE Favorites in 
#* Temp\IE-<date> folder on Favorites bar
#* Origin: http://bit.ly/zzuY8E - Alex Angelopoulos
#*=============================================================================


#From http://www.windowsitpro.com/article/windows-powershell/retrieve-information-from-open-browsing-sessions
Param([switch]$Full, [switch]$Location, [switch]$Content, [switch]$Add)

$urls = (New-Object -ComObject Shell.Application).Windows() |
Where-Object {$_.LocationUrl -match "(^https?://.+)|(^ftp://)"} |
Where-Object {$_.LocationUrl}
Write-Host "`n" $urls.count "tabs (excluding any HTTPS and FTP tabs)`n"

	#Full - spits out tabs as hash table that can be manipulated in PowerShell
	if($Full){$urls}
	#Location - gets the location
	elseif($Location) {$urls | select Location*}
	#Content - gets Name, URL and page body (text)
	elseif($Content) {$urls | ForEach-Object {$ie.LocationName;$ie.LocationUrl;$_.Document.body.innerText }}
		#Modified to add the -Add option, saves tabs as Internet Explorer Favorites in Temp > IE-<date>
		elseif($Add) {
		  $folderbase = "$home\Favorites\links\Temp\IE-" + @(get-date -format m) + " " +(get-date).year
		  $folder = $folderbase;  $number = $null
		  while(test-path $folder) {write-host "Folder exists: $folder" -foregroundcolor "red" -backgroundcolor "gray";$number = $number + 1; $folder=$folderbase + "-" + $number; write-host "::New folder name:$folder `n"}
		  $wshshell = New-Object -Com Wscript.Shell  
		  write-host "Creating folder $folder" -foregroundcolor "green";[IO.Directory]::CreateDirectory("$folder") 
		  write-host "`nSaving Favorites`n" -foregroundcolor "green"
		  $urlno = 0
		  $urls | ForEach-Object {
		  $urlno = $urlno + 1
		  $linkname = $_.LocationName
		  #write-host "Linkname" $linkname
		  #Scrub file name
		  $linkname=@([System.Text.RegularExpressions.Regex]::Replace($linkname,"http://","")) 
		  $linkname=@([System.Text.RegularExpressions.Regex]::Replace($linkname,"[\?]",""))    
		  $linkname = @( [System.Text.RegularExpressions.Regex]::Replace($linkname,"[^1-9a-zA-Z\s?_]","")) 
		  $linkname = "$linkname.url"
		  
		  #write-host "LinkName: " $linkname
		  write-host $urlno $_.locationname
		  #create shortcut
		  $link = $wshshell.CreateShortcut(@($folder + "\" + $linkname))
		  # write-host "Created shortcut object"
		  $link.TargetPath = $_.LocationUrl
		  # Write-host "Wrote targetpath" $ie.LocationUrl
		  $link.save() 
		  #Write-host "Saved"
		  } 
		}

		  #spits out the URL if no options are specified    
		  else {$urls | ForEach-Object {$_.LocationUrl}
}



